<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Task40.20 Course list</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>
<body>
    <div class = "container">
        <div class = "text-center">
            <h2>Danh sách các khóa học</h2>
        </div>
        <div class = "form-group">
            <button class = "btn btn-success float-right" id="btn-add-course"><i class="fa fa-plus"></i>&nbsp; New Course</button>
        </div>
        <table class = "table table-border table-striped table-hover" id="course-table">
            <thead>
                <tr>
                    <th>Id</th>
                    <th>Course Code</th>
                    <th>Course Name</th>
                    <th>Price</th>
                    <th>Discount Price</th>
                    <th>Duration</th>
                    <th>Level</th>
                    <th>Cover Image</th>
                    <th>Teacher Name</th>
                    <th>Teacher Photo</th>
                    <th>Is Popular</th>
                    <th>Is Trending</th>
                    <th>Action</th>
                </tr>
            </thead>
        </table>
    </div>
    <!-- Create course modal-->
    <div id="create-course-modal" class="modal fade" tabindex="-1">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">Create New course</h5>
                    <button type="button" class="close" data-dismiss="modal">&times;</button>
                </div>
                <!-- Modal body - chứa form dữ liệu -->
                <div class="modal-body"> 
                    <form> <!-- form thiết kế như form bình thường, theo grid model -->
                    <div class="row form-group">
                        <label class="col-sm-4 col-form-label">Course Code</label>
                        <div class="col-sm-8">
                        <input class="form-control" id="input-create-course-code">
                        </div>
                    </div>
    
                    <div class="row form-group">
                        <label class="col-sm-4 col-form-label">Course Name</label>
                        <div class="col-sm-8">
                        <input class="form-control" id="input-create-course-name">
                        </div>
                    </div>
                    <div class="row form-group">
                        <label class="col-sm-4 col-form-label">Price</label>
                        <div class="col-sm-8">
                        <input class="form-control" id="input-create-course-price">
                        </div>
                    </div>
                    <div class="row form-group">
                        <label class="col-sm-4 col-form-label">Discount Price</label>
                        <div class="col-sm-8">
                        <input class="form-control" id="input-create-course-discount-price">
                        </div>
                    </div>
                    <div class="row form-group">
                        <label class="col-sm-4 col-form-label">Duration</label>
                        <div class="col-sm-8">
                        <input class="form-control" id="input-create-course-duration">
                        </div>
                    </div>
                    <div class="row form-group">
                        <label class="col-sm-4 col-form-label">Level</label>
                        <div class="col-sm-8">
                        <select class="form-control" id="select-create-course-level">
                            <option value="Beginner">Beginner</option>
                            <option value="Intermediate">Intermediate</option>
                            <option value="Advanced">Advanced</option>
                        </select>
                        </div>
                    </div>

                    <div class="row form-group">
                        <label class="col-sm-4 col-form-label">Cover Image</label>
                        <div class="col-sm-8">
                        <input class="form-control" id="input-create-course-cover-image">
                        </div>
                    </div>
                    <div class="row form-group">
                        <label class="col-sm-4 col-form-label">Teacher Name</label>
                        <div class="col-sm-8">
                        <input class="form-control" id="input-create-course-teacher-name">
                        </div>
                    </div>
                    <div class="row form-group">
                        <label class="col-sm-4 col-form-label">Teacher Photo</label>
                        <div class="col-sm-8">
                        <input class="form-control" id="input-create-course-teacher-photo">
                        </div>
                    </div>
                    </form>
                </div>
                <div class="modal-footer">
                    <button type="button" id="btn-create-course" class="btn btn-primary">Create Course</button>
                    <button type="button" id="btn-create-cancel" class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                </div>
            </div>
        </div>
    </div>

    <!-- Edit course modal-->
    <div id="edit-course-modal" class="modal fade" tabindex="-1">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">Edit course detail</h5>
                    <button type="button" class="close" data-dismiss="modal">&times;</button>
                </div>
                <!-- Modal body - chứa form dữ liệu -->
                <div class="modal-body"> 
                    <form> <!-- form thiết kế như form bình thường, theo grid model -->
                    <div class="row form-group">
                        <label class="col-sm-4 col-form-label">Course Code</label>
                        <div class="col-sm-8">
                        <input class="form-control" id="input-edit-course-code">
                        </div>
                    </div>
    
                    <div class="row form-group">
                        <label class="col-sm-4 col-form-label">Course Name</label>
                        <div class="col-sm-8">
                        <input class="form-control" id="input-edit-course-name">
                        </div>
                    </div>
                    <div class="row form-group">
                        <label class="col-sm-4 col-form-label">Price</label>
                        <div class="col-sm-8">
                        <input class="form-control" id="input-edit-course-price">
                        </div>
                    </div>
                    <div class="row form-group">
                        <label class="col-sm-4 col-form-label">Discount Price</label>
                        <div class="col-sm-8">
                        <input class="form-control" id="input-edit-course-discount-price">
                        </div>
                    </div>
                    <div class="row form-group">
                        <label class="col-sm-4 col-form-label">Duration</label>
                        <div class="col-sm-8">
                        <input class="form-control" id="input-edit-course-duration">
                        </div>
                    </div>
                    <div class="row form-group">
                        <label class="col-sm-4 col-form-label">Level</label>
                        <div class="col-sm-8">
                        <select class="form-control" id="select-edit-course-level">
                            <option value="Beginner">Beginner</option>
                            <option value="Intermediate">Intermediate</option>
                            <option value="Advanced">Advanced</option>
                        </select>
                        </div>
                    </div>

                    <div class="row form-group">
                        <label class="col-sm-4 col-form-label">Cover Image</label>
                        <div class="col-sm-8">
                        <input class="form-control" id="input-edit-course-cover-image">
                        </div>
                    </div>
                    <div class="row form-group">
                        <label class="col-sm-4 col-form-label">Teacher Name</label>
                        <div class="col-sm-8">
                        <input class="form-control" id="input-edit-course-teacher-name">
                        </div>
                    </div>
                    <div class="row form-group">
                        <label class="col-sm-4 col-form-label">Teacher Photo</label>
                        <div class="col-sm-8">
                        <input class="form-control" id="input-edit-course-teacher-photo">
                        </div>
                    </div>
                    <div class="row form-group">
                        <label class="col-sm-4 col-form-label">Is popular</label>
                        <div class="col-sm-8">
                        <select class="form-control" id="select-edit-course-popular">
                            <option value = true>Yes</option>
                            <option value = false>No</option>
                        </select>
                        </div>
                    </div>
                    <div class="row form-group">
                        <label class="col-sm-4 col-form-label">Is trending</label>
                        <div class="col-sm-8">
                        <select class="form-control" id="select-edit-course-trending">
                            <option value = true>Yes</option>
                            <option value = false>No</option>
                        </select>
                        </div>
                    </div>
                    </form>
                </div>
                <div class="modal-footer">
                    <button type="button" id="btn-edit-course" class="btn btn-primary">Update Course</button>
                    <button type="button" id="btn-edit-cancel" class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                </div>
            </div>
        </div>
    </div>
    <!-- Delete confirm modal -->
    <div>
        <div class="modal fade" tabindex="-1" id="delete-course-modal">
        <div class="modal-dialog">
            <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="h5-modal-title">Confirm xóa khóa học</h5>
                <button class="close" data-dismiss="modal">&times;</button>
            </div>
            <div class="modal-body">
                <label>Bạn có chắc chắn muốn xóa khóa học này không?</label>
            </div>
            <div class="modal-footer">
                <button class="btn btn-danger" id="btn-confirm-delete-course">Xác nhận</button>
                <button class="btn btn-secondary" data-dismiss="modal">Hủy bỏ</button>
            </div>
            </div>
        </div>
        </div>
    </div>

</body>
<script>
    "use strict";
    
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_CREATE_OK = 201; // status 201 là tạo mới thành công
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gCONTENT_TYPE = "application/json";
    var gBASE_URL = "https://624abe0dfd7e30c51c110ac6.mockapi.io/api/v1/";
    // Biến toàn cục để lưu trữ id course đang đc update or delete. Mặc định = 0;
    var gCourseId = 0;
    var gCourseObj = {};

    var gCoursesArr =[];
    const gCOLUMN_ID = 0;
    const gCOLUMN_COURSE_CODE = 1;
    const gCOLUMN_COURSE_NAME = 2;
    const gCOLUMN_PRICE = 3;
    const gCOLUMN_DISCOUNT_PRICE = 4 ;
    const gCOLUMN_DURATION = 5;
    const gCOLUMN_LEVEL = 6;
    const gCOLUMN_COVER_IMAGE = 7;
    const gCOLUMN_TEACHER_NAME = 8;
    const gCOLUMN_TEACHER_PHOTO = 9;
    const gCOLUMN_IS_POPULAR = 10;
    const gCOLUMN_IS_TRENDING = 11;
    const gCOLUMN_ACTION = 12;

    const gCOURSE_COL = ["id","courseCode","courseName","price","discountPrice","duration","level","coverImage"
    ,"teacherName","teacherPhoto","isPopular","isTrending", "action"]
    
    // khởi tạo data table  - chưa có data
    var gCourseTable = $("#course-table").DataTable( {
      // Khai báo các cột của datatable
      "columns" : [
          { "data" : gCOURSE_COL[gCOLUMN_ID] },
          { "data" : gCOURSE_COL[gCOLUMN_COURSE_CODE] },
          { "data" : gCOURSE_COL[gCOLUMN_COURSE_NAME] },
          { "data" : gCOURSE_COL[gCOLUMN_PRICE] },
          { "data" : gCOURSE_COL[gCOLUMN_DISCOUNT_PRICE] },
          { "data" : gCOURSE_COL[gCOLUMN_DURATION] },
          { "data" : gCOURSE_COL[gCOLUMN_LEVEL] },
          { "data" : gCOURSE_COL[gCOLUMN_COVER_IMAGE] },
          { "data" : gCOURSE_COL[gCOLUMN_TEACHER_NAME] },
          { "data" : gCOURSE_COL[gCOLUMN_TEACHER_PHOTO] },
          { "data" : gCOURSE_COL[gCOLUMN_IS_POPULAR] },
          { "data" : gCOURSE_COL[gCOLUMN_IS_TRENDING] },
          { "data" : gCOURSE_COL[gCOLUMN_ACTION] }
      ],
      // Ghi đè nội dung của cột action, chuyển thành button chi tiết
      "columnDefs": [
        {
            targets: gCOLUMN_PRICE,
            render: function(data){
                return data + "$";
            }
        },
        {
            targets: gCOLUMN_DISCOUNT_PRICE,
            render: function(data){
                return data + "$";
            }
        },
        {
            targets: gCOLUMN_COVER_IMAGE,
            className: "text-center",
            data: "img",
            render: function(data){
                return '<img src="'+ data + '"alt"' + data + '"height = "100%" width = "100%"/>';
            }
        },
        {targets: gCOLUMN_TEACHER_PHOTO,
        className: "text-center",
        data: "img",
        render: function(data){
            return '<img src="'+ data + '"alt"' + data + '"height = "75%" width = "75%" class = "rounded-circle"/>';
        }},
        {
          "targets": gCOLUMN_ACTION,
          "defaultContent": `
            <button class="btn btn-primary edit-course"><i class="far fa-edit"></i> Sửa</button>
            <button class="btn btn-danger delete-course"><i class="far fa-trash-alt"></i> Xóa</button>
            `
        }]
    });
    
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function(){
        onPageLoading();
    });
    //2-C: gán sự kiện thêm mới
    $("#btn-add-course").on("click",function(){
        onBtnAddNewCourseClick(this);
    });
    //gán sự kiện cho các nút trên create course modal
    $("#btn-create-course").on("click",function(){
        onBtnCreateCourseClick(this);
    });
    //3-U: gán sự kiện sửa
    $("#course-table").on("click",".edit-course",function(){
        onBtnEditCourseClick(this);
    });
    //gán sự kiện cho các nút trên update course modal, chưa khai báo hàm gọi API để update course
    $("#btn-edit-course").on("click",function(){
        onBtnUpdateCourseClick(this);
    });

    //4-D: gán sự kiện nút xóa 
    $("#course-table").on("click",".delete-course",function(){
        onBtnDeleteCourseClick(this);
    });
    //gán sự kiện cho nút xác nhận xóa course trên modal, chưa khai báo hàm gọi API để delete course
    $("#btn-confirm-delete-course").on("click",function(){
        onBtnConfirmDeleteCourseClick(this);
    });

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading(){
        callApiGetDataCourse();       
    };
    //hàm xử lý sự kiện ấn nút add course
    function onBtnAddNewCourseClick(){
        //hiển thị modal lên
        $("#create-course-modal").modal("show");
    }
    //hàm xử lý sự kiện nhấn nút create course trên modal
    function onBtnCreateCourseClick(){
        //khai báo đối tượng course obj
        var vObjectRequestData = {
            courseCode:"",
            courseName: "",
            price: "",
            discountPrice: "",
            duration: "",
            level:"",
            coverImage: "",
            teacherName: "",
            teacherPhoto: "",
            isPopular: false,
            isTrending: false
        }
        //b1: thu thập dữ liệu input trên modal
        getInsertCourseData(vObjectRequestData);
        //b2: validate
        var vIsValid = validateCourseData(vObjectRequestData);
        //b3: gọi API thêm course
        if(vIsValid){
            ajaxCreateCourse(vObjectRequestData);
        };
    }
    function onBtnEditCourseClick(paramButton){
        //lưu thông tin course id vào biến toàn cục
        gCourseId = getCourseIdFromButton(paramButton);

        console.log("Nút sửa được ấn, id của course tương ứng là: " + gCourseId);
        //hiển thị modal lên
        $("#edit-course-modal").modal("show");
        loadCourseDataToCourseEditModal(gCourseObj);
    }
    //hàm xử lý sự kiện nhấn nút update course trên modal
    function onBtnUpdateCourseClick(){
        //khai báo đối tượn course obj
        var vObjectRequestData = {
            courseCode:"",
            courseName: "",
            price:"",
            discountPrice:"",
            duration: "",
            level:"",
            teacherName: "",
            teacherPhoto: "",
            isPopular: false,
            isTrending: false
        }
        //b1: thu thập dữ liệu input trên modal
        getEditedCourseData(vObjectRequestData);
        //b2: validate
        var vIsValid = validateCourseData(vObjectRequestData);
        //b3: gọi API sửa course
        if(vIsValid){
            ajaxUpdateCourse(vObjectRequestData);
        };
    }
    function onBtnDeleteCourseClick(paramButton){
      //lưu thông tin course id vào biến toàn cục
      gCourseId = getCourseIdFromButton(paramButton);
        
      console.log("Nút xóa được ấn, id của course tương ứng là: " + gCourseId);
      //hiển thị modal lên
      $("#delete-course-modal").modal("show");      
    }
    //hàm xử lý sự kiện xác nhận xóa course
    function onBtnConfirmDeleteCourseClick(){
        "use strict";
        //gọi API xóa course
        ajaxDeleteCourse(gCourseId);
    }
    
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //hàm load data course
    function callApiGetDataCourse(){
        "use strict";
        $.ajax({
            url: gBASE_URL + "/courses",
            type: "GET",
            dataType: "json",
            success: function (paramRes){
                console.log(paramRes);
                loadDataToCourseTable(paramRes);
            },
            error: function (ajaxContext){
                console.log(ajaxContext.responseText)
            }
        });
    }
    //hàm load dữ liệu vào course data table
    function loadDataToCourseTable(paramCourses){
      //Xóa toàn bộ dữ liệu đang có của bảng
      gCourseTable.clear();
      //Cập nhật data cho bảng 
      gCourseTable.rows.add(paramCourses);
      //Cập nhật lại giao diện hiển thị bảng
      gCourseTable.draw();
    }
    //hàm đọc thông tin course data được thêm
    function getInsertCourseData(paramCourseObj){
        paramCourseObj.courseCode = $("#input-create-course-code").val().trim();
        paramCourseObj.courseName = $("#input-create-course-name").val().trim();
        paramCourseObj.price = $("#input-create-course-price").val().trim();
        paramCourseObj.discountPrice = $("#input-create-course-discount-price").val().trim();
        paramCourseObj.duration = $("#input-create-course-duration").val().trim();
        paramCourseObj.level = $("#select-create-course-level").val();
        paramCourseObj.coverImage = $("#input-create-course-cover-image").val().trim();
        paramCourseObj.teacherName = $("#input-create-course-teacher-name").val().trim();
        paramCourseObj.teacherPhoto = $("#input-create-course-teacher-photo").val().trim();
    }

    //API thêm khóa học - hàm này cần kiểm tra lại sample API
    function ajaxCreateCourse(paramCourseRequest){
        "use strict";
        $.ajax({
            url: gBASE_URL + "/courses",
            type: "POST",
            contentType: gCONTENT_TYPE,
            data: JSON.stringify(paramCourseRequest),
            success: function(paramRes){
                console.log(paramRes);
                //b4: xử lý hiển thị
                handleCreateCourseSuccess();
            },
            error: function(paramErr){
                console.log(paramErr.status);
            }
        });
    }
    //hàm xử lý hiển thị khi thêm course mới thành công
    function handleCreateCourseSuccess(){
        alert("Thêm course thành công!");
        //reload data on table
        loadDataToCourseTable();
        resetCreateForm();
        $("#create-course-modal").modal("hide");
    }
    //hàm xóa thông tin trên form create course modal
    function resetCreateForm(){
        $("#input-create-course-code").val("");
        $("#input-create-course-name").val("");
        $("#input-create-course-price").val("");
        $("#input-create-course-discount-price").val("");
        $("#input-create-course-duration").val("");
        $("#input-create-course-cover-image").val("");
        $("#input-create-course-teacher-name").val("");
        $("#input-create-course-teacher-photo").val("");
    };
    //hàm validate course data
    function validateCourseData(paramCourseObj){
        if (paramCourseObj.courseCode == "" ||
        paramCourseObj.courseName == "" ||
        paramCourseObj.price == ""||
        paramCourseObj.discountPrice == ""||
        paramCourseObj.duration == ""||
        paramCourseObj.coverImage == ""||
        paramCourseObj.teacherName == ""||
        paramCourseObj.teacherPhoto == ""){
            alert("Cần nhập đầy đủ thông tin");
            return false;
        }
        return true;
    }
    //hàm xác định course id từ button
    function getCourseIdFromButton(paramButton){
        var vTableRow = $(paramButton).parents("tr");
        var vCourseRowData = gCourseTable.row(vTableRow).data();
        gCourseObj = vCourseRowData;
        return vCourseRowData.id;
    }
    //hàm load thông tin course ban đầu lên modal
    function loadCourseDataToCourseEditModal(paramCourseObj){
        $("#input-edit-course-code").val(paramCourseObj.courseCode);
        $("#input-edit-course-name").val(paramCourseObj.courseName);
        $("#input-edit-course-price").val(paramCourseObj.price);
        $("#input-edit-course-discount-price").val(paramCourseObj.discountPrice);
        $("#input-edit-course-duration").val(paramCourseObj.duration);
        $("#select-edit-course-level").val(paramCourseObj.level);
        $("#input-edit-course-cover-image").val(paramCourseObj.coverImage);
        $("#input-edit-course-teacher-name").val(paramCourseObj.teacherName);
        $("#input-edit-course-teacher-photo").val(paramCourseObj.teacherPhoto);
        $("#select-edit-course-popular").val(paramCourseObj.isPopular);
        $("#select-edit-course-trending").val(paramCourseObj.isTrending);
    }
    //hàm đọc thông tin course data được edited
    function getEditedCourseData(paramCourseObj){
        paramCourseObj.courseCode = $("#input-edit-course-code").val();
        paramCourseObj.courseName = $("#input-edit-course-name").val();
        paramCourseObj.price = $("#input-edit-course-price").val();
        paramCourseObj.discountPrice = $("#input-edit-course-discount-price").val();
        paramCourseObj.duration = $("#input-edit-course-duration").val();
        paramCourseObj.level = $("#select-edit-course-level").val();
        paramCourseObj.coverImage = $("#input-edit-course-cover-image").val();
        paramCourseObj.teacherName = $("#input-edit-course-teacher-name").val();
        paramCourseObj.teacherPhoto = $("#input-edit-course-teacher-photo").val();
        paramCourseObj.isPopular = $("#select-edit-course-popular").val();
        paramCourseObj.isTrending = $("#select-edit-course-trending").val();
    }
    //API update course
    function ajaxUpdateCourse(paramCourseRequest){
        "use strict";
        $.ajax({
            url:  gBASE_URL + "/courses/" + gCourseId,
            type: "PUT",
            contentType: gCONTENT_TYPE,
            data: JSON.stringify(paramCourseRequest),
            success: function(paramRes){
                console.log(paramRes);
                //b4: xử lý hiển thị
                handleUpdateCourseSuccess();
            },
            error: function(paramErr){
                console.log(paramErr.status);
            }
        });
    }
    //hàm xử lý hiển thị khi course cập nhật thành công
    function handleUpdateCourseSuccess(){
        alert("Cập nhật khóa học thành công!");
        //reload data on table
        callApiGetDataCourse();
        $("#edit-course-modal").modal("hide");
    }
    //API delete course
    function ajaxDeleteCourse(paramCourseId){
        "use strict";
        $.ajax({
            url:  gBASE_URL + "/courses/" + gCourseId,
            type: "DELETE",
            success: function(paramRes){
                console.log(paramRes);
                //b4: xử lý hiển thị
                handleDeleteCourseSuccess();
            },
            error: function(paramErr){
                console.log(paramErr.status);
            }
        });
    }
    //hàm xử lý hiển thị khi xóa course thành công
    function handleDeleteCourseSuccess(){
        alert("Xóa course thành công!");
        //reload data on table
        callApiGetDataCourse();
        $("#delete-course-modal").modal("hide");
    }
</script>
</html>